<script setup>
import { ref } from "vue";

const emit = defineEmits(["toggled", "onOpen", "onClose"]);
defineExpose({
  toggleFold: () => toggle(),
});
const isFoldedOut = ref(false);

function toggle(e) {
  isFoldedOut.value = !isFoldedOut.value;
  emit("toggled", e);
  isFoldedOut.value ? emit("onOpen") : emit("onClose");
}
</script>

<template>
  <div>
    <div class="header" @click="toggle">
      <slot name="header" :toggle-fold="toggle"></slot>
    </div>
    <slot v-if="isFoldedOut" :toggle-fold="toggle"></slot>
  </div>
</template>
